﻿//=================================================================
//
//				The Tamer - Plugin Version 1.2
//						Autor: katzerle
//			Honorbuddy Plugin - www.thebuddyforum.com
//               Credits to all the brave Testers
//
//==================================================================
using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Xml.Linq;
using System.Diagnostics;
using System.IO;
using System.Xml;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Media;

using Styx;
using Styx.Logic.Combat;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins.PluginClass;
using Styx.Logic.BehaviorTree;

using Styx.Logic.Pathing;
using Styx.Combat.CombatRoutine;
using Styx.Logic.Inventory.Frames.Quest;
using Styx.Logic.Questing;
using Styx.Plugins;
using Styx.Logic.Inventory.Frames.Gossip;
using Styx.Logic.Common;
using Styx.Logic.Inventory.Frames.Merchant;
using Styx.Logic;
using Styx.Logic.Profiles;
using Styx.Logic.Inventory.Frames.LootFrame;

namespace katzerle
{
    class TheTamer : HBPlugin
    {
        public static string name { get { return "The Tamer"; } }
        public override string Name { get { return name; } }
        public override string Author { get { return "katzerle"; } }
        private readonly static Version _version = new Version(1, 2);
        public override Version Version { get { return _version; } }
        public override string ButtonText { get { return "Settings"; } }
        public override bool WantButton { get { return true; } }
        public static LocalPlayer Me = ObjectManager.Me;
        public static TheTamerSettings Settings = new TheTamerSettings();

        public TheTamer()
        {
            Log("The Tamer Version 1.2 Loaded.");
            Settings.Load();
            if (Me.Class != WoWClass.Hunter)
               Log("Plugin Tamer: I'm no Hunter. The Tamer doesn't work");
        }

        public override void OnButtonPress()
        {
            Settings.Load();
            ConfigForm.ShowDialog();
        }

        private Form MyForm;
        public Form ConfigForm
        {
            get
            {
                if (MyForm == null)
                    MyForm = new TheTamerUI();
                return MyForm;
            }
        }


        public override void Pulse()
        {
            try
            {
                if (!inCombat)
                {
                    if (Me.Class == WoWClass.Hunter)
                    {
                        if (Me.HealthPercent > 30)
                            findAndTameMob();
                        else
                            return;
                    }
                    else
                        return;
                }
            }
            catch (ThreadAbortException) { }
            catch (Exception e)
            {
                Log("Plugin The Tamer: Exception in Pulse:{0}", e);
            }
        }

        static public void findAndTameMob()
        {
            int dist = 12;
            string File = "Plugins\\TheTamer\\";
            string sPath = Process.GetCurrentProcess().MainModule.FileName;
            sPath = Path.GetDirectoryName(sPath);
            sPath = Path.Combine(sPath, File);
            sPath = Path.Combine(sPath, "siren1.wav");

            ObjectManager.Update();
            List<WoWUnit> objList = ObjectManager.GetObjectsOfType<WoWUnit>()
                .Where(o => (
                (Settings.Default && ((o.Entry == 50051) // Ghostcrawler
                        || (o.Entry == 50138)			// Karoma
                        || (o.Entry == 49822)			// Jadefang
                        || (o.Entry == 51401)			// Madexx Red
                        || (o.Entry == 51402)			// Madexx Green
                        || (o.Entry == 51403)			// Madexx Black
                        || (o.Entry == 51404)			// Madexx Blue
                        || (o.Entry == 50154)			// Madexx Brown				
                        || (o.Entry == 50058)			// Terrorpene
                        || (o.Entry == 32517)			// Loque'nahak
                        || (o.Entry == 32481)			// Aotona
                        || (o.Entry == 35189)			// Skoll
                        || (o.Entry == 33776)			// Gondria
                        || (o.Entry == 38543)			// Arcturis
						|| (o.Entry == 32485)			// King Krush
						|| (o.Entry == 20932)			// Nuramoc
						|| (o.Entry == 17144)			// Goretooth
						|| (o.Entry == 32485)			// King Krush
                        || (o.Entry == 50159)))			// Sambas
                || (Settings.HUNTbyID && (o.Entry == Convert.ToInt32(Settings.MobID))) 	// Hunt by ID
                ))
                .OrderBy(o => o.Distance).ToList();
            foreach (WoWUnit o in objList)
            {
                if (!o.Dead && !o.IsPet && o.IsTameable && !Blacklist.Contains(o.Entry))
                {
                    if (Settings.Alert)
                        new SoundPlayer(sPath).Play();
                    Log("Plugin The Tamer: Found a new Pet {0} !!!", o.Name);
					if (!SpellManager.HasSpell("Beast Mastery"))
                    {
                        Log("Plugin The Tamer: Can't Tame it without Beast Mastery. Mob Blacklistet for 2 minutes");
						Blacklist.Add(o.Entry, TimeSpan.FromSeconds(120));
                        return;
                    }					
                    if (inCombat)
                    {
                        Log("Plugin The Tamer: ... but I'm in another Combat :( !!!");
                        return;
                    }
                    if (Me.Level < o.Level)
                    {
                        Log("Plugin The Tamer: Mob Level is higher then mine, can't tame the Mob. Mob Blacklistet for 5 minutes");
						Blacklist.Add(o.Entry, TimeSpan.FromSeconds(300));
                        return;
                    }

                    WoWPoint newPoint = WoWMovement.CalculatePointFrom(o.Location, (float)dist);
                    if (Settings.GroundMount || (o.Entry == 49822))
                    {
                        while (newPoint.Distance(Me.Location) > dist)
                        {
                            Log("Plugin The Tamer: Walking to target");
                            Navigator.MoveTo(newPoint);
                            Thread.Sleep(100);
                            if (inCombat) return;
                        }
                    }

                    else
                    {
                        while (newPoint.Distance(Me.Location) > dist)
                        {
                            Log("Plugin The Tamer: Flying to target");
                            Flightor.MoveTo(newPoint);
                            Thread.Sleep(100);
                            if (inCombat) return;
                        }
                    }

                    if (Me.Mounted)
                        Mount.Dismount();

                    SpellManager.Cast("Dismiss Pet");
                    Thread.Sleep(1000);

                    o.Target();
                    o.Face();
                    while (!o.IsPet)
                    {
                        if (o.Dead)
                        {
                            Log("Plugin The Tamer: Mob was dying, I'm so Sorry !!! ");
                            return;
                        }
                        if (Me.HealthPercent < 10)
                        {
                            Log("Plugin The Tamer: Health < 10% , Use Feign Death !!! ");
                            SpellManager.Cast("Feign Death");
                            return;
                        }

                        if (!Me.IsCasting)
                        {
                            WoWMovement.MoveStop();
                            SpellManager.Cast("Tame Beast");
							Log("Plugin The Tamer: Try to tame Beast {0}", o.Name);
                            Thread.Sleep(1500);
                        }
                    }
                    Log("Plugin The Tamer: Sucessfully tamed Beast {0}", o.Name);
                }
				else if(o.IsPet)
					return;
                else
                    Log("Plugin The Tamer: Find a Mob, but sadly he's dead or not tameable: {0}", o.Name);
            }
        }
        static public void Log(string msg, params object[] args) { Logging.Write(msg, args); }
        static public void Log(System.Drawing.Color c, string msg, params object[] args) { Logging.Write(c, msg, args); }

        static public bool inCombat
        {
            get
            {
                if (Me.Combat || Me.Dead || Me.IsGhost) return true;
                return false;
            }
        }

        public static int GetPing
        {
            get
            {
                return Lua.GetReturnVal<int>("Plugin The Tamer: return GetNetStats()", 2);
            }
        }
    }
}
