﻿//=================================================================
//
//				       The Tamer - Plugin
//						Autor: katzerle
//			Honorbuddy Plugin - www.thebuddyforum.com
//               Credits to all the brave Testers
//
//==================================================================
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Runtime.Serialization;
using System.Xml;
using Styx;
using Styx.Combat.CombatRoutine;
using Styx.Helpers;
using Styx.WoWInternals;
using ObjectManager = Styx.WoWInternals.ObjectManager;

namespace katzerle
{
    class TheTamerSettings
    {
        string File = "Plugins\\TheTamer\\config\\";
        public TheTamerSettings()
        {
            if (ObjectManager.Me != null)
                try
                {
                    Load();
                }
                catch (Exception e)
                {
                    Logging.Write(e.Message);
                }
        }

        public bool Default = true;
        public bool HUNTbyID = false;
        public string MobID = "";
        public bool GroundMount = false;
        public bool Alert = true;

        public void Load()
        {
            //    XmlTextReader reader;
            XmlDocument xml = new XmlDocument();
            XmlNode xvar;

            string sPath = Process.GetCurrentProcess().MainModule.FileName;
            sPath = Path.GetDirectoryName(sPath);
            sPath = Path.Combine(sPath, File);

            if (!Directory.Exists(sPath))
            {
                Logging.WriteDebug("Plugin The Tamer: Creating config directory");
                Directory.CreateDirectory(sPath);
            }

            sPath = Path.Combine(sPath, "TheTamer.config");

            Logging.WriteDebug("Plugin The Tamer: Loading config file: {0}", sPath);
            System.IO.FileStream fs = new System.IO.FileStream(@sPath, System.IO.FileMode.OpenOrCreate, System.IO.FileAccess.ReadWrite);
            try
            {
                xml.Load(fs);
                fs.Close();
            }
            catch (Exception e)
            {
                Logging.Write(e.Message);
                Logging.Write("Plugin The Tamer: Continuing with Default Config Values");
                fs.Close();
                return;
            }

            //            xml = new XmlDocument();

            try
            {
                //                xml.Load(reader);
                if (xml == null)
                    return;

                xvar = xml.SelectSingleNode("//TheTamer/Default");
                if (xvar != null)
                {
                    Default = Convert.ToBoolean(xvar.InnerText);
                    Logging.WriteDebug("Plugin The Tamer: " + xvar.Name + "=" + Default.ToString());
                }

                xvar = xml.SelectSingleNode("//TheTamer/HUNTbyID");
                if (xvar != null)
                {
                    HUNTbyID = Convert.ToBoolean(xvar.InnerText);
                    Logging.WriteDebug("Plugin The Tamer: " + xvar.Name + "=" + HUNTbyID.ToString());
                }


                xvar = xml.SelectSingleNode("//TheTamer/MobID");
                if (xvar != null)
                {
                    MobID = Convert.ToString(xvar.InnerText);
                    Logging.WriteDebug("Plugin The Tamer: " + xvar.Name + "=" + MobID.ToString());
                }

                xvar = xml.SelectSingleNode("//TheTamer/GroundMount");
                if (xvar != null)
                {
                    GroundMount = Convert.ToBoolean(xvar.InnerText);
                    Logging.WriteDebug("Plugin The Tamer: " + xvar.Name + "=" + GroundMount.ToString());
                }

                xvar = xml.SelectSingleNode("//TheTamer/Alert");
                if (xvar != null)
                {
                    Alert = Convert.ToBoolean(xvar.InnerText);
                    Logging.WriteDebug("Plugin The Tamer: " + xvar.Name + "=" + Alert.ToString());
                }

            }
            catch (Exception e)
            {
                Logging.WriteDebug("Plugin The Tamer: PROJECTE EXCEPTION, STACK=" + e.StackTrace);
                Logging.WriteDebug("Plugin The Tamer: PROJECTE EXCEPTION, SRC=" + e.Source);
                Logging.WriteDebug("Plugin The Tamer: PROJECTE : " + e.Message);
            }
        }  
    }
}
