﻿//=================================================================
//
//				       The Tamer - Plugin
//						Autor: katzerle
//			Honorbuddy Plugin - www.thebuddyforum.com
//               Credits to all the brave Testers
//
//==================================================================
using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Xml.Linq;
using System.Diagnostics;
using System.IO;
using System.Xml;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.Serialization;
using System.Media;

using Styx;
using Styx.Logic.Combat;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins.PluginClass;
using Styx.Logic.BehaviorTree;

using Styx.Logic.Pathing;
using Styx.Combat.CombatRoutine;
using Styx.Logic.Inventory.Frames.Quest;
using Styx.Logic.Questing;
using Styx.Plugins;
using Styx.Logic.Inventory.Frames.Gossip;
using Styx.Logic.Common;
using Styx.Logic.Inventory.Frames.Merchant;
using Styx.Logic;
using Styx.Logic.Profiles;
using Styx.Logic.Inventory.Frames.LootFrame;



namespace katzerle
{
    public partial class TheTamerUI : Form
    {
        public TheTamerUI()
        {
            InitializeComponent();
            CBDefault.Checked = TheTamer.Settings.Default;
            CBHUNTbyID.Checked = TheTamer.Settings.HUNTbyID;
            TBHUNTbyID.Text = TheTamer.Settings.MobID;
            CBGroundMount.Checked = TheTamer.Settings.GroundMount;
            CBAlert.Checked = TheTamer.Settings.Alert;
        }

        private void CBHUNTbyID_CheckedChanged(object sender, EventArgs e)
        {
            if (CBHUNTbyID.Checked)
                TBHUNTbyID.Enabled = true;
            else
                TBHUNTbyID.Enabled = false;
        }

        private void BSave_Click(object sender, EventArgs e)
        {
            string File = "Plugins\\TheTamer\\config\\";
			Logging.Write("Plugin The Tamer: SettingsSaved!");

            XmlDocument xml;
            XmlElement root;
            XmlElement element;
            XmlText text;
            XmlComment xmlComment;

            string sPath = Process.GetCurrentProcess().MainModule.FileName;
            sPath = Path.GetDirectoryName(sPath);

            TheTamer.Settings.Default = CBDefault.Checked;
            TheTamer.Settings.HUNTbyID = CBHUNTbyID.Checked;
            TheTamer.Settings.MobID = TBHUNTbyID.Text;
            TheTamer.Settings.GroundMount = CBGroundMount.Checked;
            TheTamer.Settings.Alert = CBAlert.Checked;

// ---------- Check Plausibility of the Config ----------------------------
			if (CBHUNTbyID.Checked && (TBHUNTbyID.Text == ""))
            {
                Logging.Write("Plugin Camel: You must insert a Mob-ID to Hunt by ID");
                CBHUNTbyID.Checked = false;
                TheTamer.Settings.HUNTbyID = false;
            }

            sPath = Path.Combine(sPath, File);

            if (!Directory.Exists(sPath))
            {
                Logging.WriteDebug("Plugin The Tamer: Creating config directory");
                Directory.CreateDirectory(sPath);
            }

            sPath = Path.Combine(sPath, "TheTamer.config");

            Logging.WriteDebug("Plugin The Tamer: Saving config file: {0}", sPath);
            xml = new XmlDocument();
            XmlDeclaration dc = xml.CreateXmlDeclaration("1.0", "utf-8", null);
            xml.AppendChild(dc);

            xmlComment = xml.CreateComment(
                "=======================================================================\n" +
                ".CONFIG  -  This is the Config File For The Tamer\n\n" +
                "XML file containing settings to customize in the The Tamer Plugin\n" +
                "It is STRONGLY recommended you use the Configuration UI to change this\n" +
                "file instead of direct changein it here.\n" +
                "========================================================================");

            //let's add the root element
            root = xml.CreateElement("TheTamer");
            root.AppendChild(xmlComment);

            //let's add another element (child of the root)
            element = xml.CreateElement("Default");
            text = xml.CreateTextNode(CBDefault.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("HUNTbyID");
            text = xml.CreateTextNode(CBHUNTbyID.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("MobID");
            text = xml.CreateTextNode(TBHUNTbyID.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("GroundMount");
            text = xml.CreateTextNode(CBGroundMount.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Alert");
            text = xml.CreateTextNode(CBAlert.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            xml.AppendChild(root);

            System.IO.FileStream fs = new System.IO.FileStream(@sPath, System.IO.FileMode.Create,
                                                               System.IO.FileAccess.Write);
            try
            {
                xml.Save(fs);
                fs.Close();
            }
            catch (Exception np)
            {
                Logging.Write(np.Message);
            }
        }

        private void BAlert_Click(object sender, EventArgs e)
        {
            string File = "Plugins\\TheTamer\\";
            string sPath = Process.GetCurrentProcess().MainModule.FileName;
            sPath = Path.GetDirectoryName(sPath);
            sPath = Path.Combine(sPath, File);
            sPath = Path.Combine(sPath, "siren1.wav");
            new SoundPlayer(sPath).Play();
        }

    }
}
